
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>jdk6 substring 内存泄露问题解析 / 憋错料</title>

    <meta name="description" content="jdk6 substring 内存泄露问题解析 测试环境 eclipse + jdk1.6.0_25 public class SubMain { private String strs = new String(new byte[100000]); String getString() {     return this.strs.substring(0, 2);   } public static void main(String[] args) {     List&lt;String&gt; list = new ArrayList& ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">jdk6 substring 内存泄露问题解析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>测试环境</p>
<p>eclipse +&nbsp;jdk1.6.0_25</p>
<p>public&nbsp;class&nbsp;SubMain&nbsp;{</p>
<p>private&nbsp;String&nbsp;strs&nbsp;=&nbsp;new&nbsp;String(new&nbsp;byte[100000]);</p>
<p>String&nbsp;getString()&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;this.strs.substring(0,&nbsp;2);<br />
&nbsp;&nbsp;}</p>
<p>public&nbsp;static&nbsp;void&nbsp;main(String[]&nbsp;args)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;List&lt;String&gt;&nbsp;list&nbsp;=&nbsp;new&nbsp;ArrayList&lt;String&gt;();<br />
&nbsp;&nbsp;&nbsp;&nbsp;for&nbsp;(int&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;1000000;&nbsp;i++)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;SubMain&nbsp;sub&nbsp;=&nbsp;new&nbsp;SubMain();<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;list.add(sub.getString());<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;}</p>
<p>}</p>
<p>运行不到一分钟后</p>
<p>Exception&nbsp;in&nbsp;thread&nbsp;"main"&nbsp;java.lang.OutOfMemoryError:&nbsp;Java&nbsp;heap&nbsp;space<br />
&nbsp;&nbsp;&nbsp;&nbsp;at&nbsp;java.lang.StringCoding$StringDecoder.decode(StringCoding.java:133)<br />
&nbsp;&nbsp;&nbsp;&nbsp;at&nbsp;java.lang.StringCoding.decode(StringCoding.java:173)<br />
&nbsp;&nbsp;&nbsp;&nbsp;at&nbsp;java.lang.StringCoding.decode(StringCoding.java:185)<br />
&nbsp;&nbsp;&nbsp;&nbsp;at&nbsp;java.lang.String.&lt;init&gt;(String.java:570)<br />
&nbsp;&nbsp;&nbsp;&nbsp;at&nbsp;java.lang.String.&lt;init&gt;(String.java:593)<br />
&nbsp;&nbsp;&nbsp;&nbsp;at&nbsp;com.jd.o2o.substring.SubMain.&lt;init&gt;(SubMain.java:8)</p>
<p>at&nbsp;com.jd.o2o.substring.SubMain.main(SubMain.java:18)</p>
<p>好吧,内存溢出了</p>
<p>查看jdk6 substring源码实现,看看为什么？我们集合中也只存储了两个字符串,不至于说会内存溢出,即使我们全局变量占用空间大的话,在我们不使用该对象时,该对象应该会被清理掉,这样也不应该导致内存溢出</p>
<p>public&nbsp;String&nbsp;substring(int&nbsp;beginIndex,&nbsp;int&nbsp;endIndex)&nbsp;{</p>
<p>if&nbsp;(beginIndex&nbsp;&lt;&nbsp;0)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(beginIndex);<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(endIndex&nbsp;&gt;&nbsp;count)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(endIndex);<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(beginIndex&nbsp;&gt;&nbsp;endIndex)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(endIndex&nbsp;-&nbsp;beginIndex);<br />
&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;((beginIndex&nbsp;==&nbsp;0)&nbsp;&amp;&amp;&nbsp;(endIndex&nbsp;==&nbsp;count))&nbsp;?&nbsp;this&nbsp;:<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;new&nbsp;String(offset&nbsp;+&nbsp;beginIndex,&nbsp;endIndex&nbsp;-&nbsp;beginIndex,&nbsp;value);<br />
&nbsp;&nbsp;&nbsp;&nbsp;}</p>
<p>String(int&nbsp;offset,&nbsp;int&nbsp;count,&nbsp;char&nbsp;value[])&nbsp;{</p>
<p>this.value&nbsp;=&nbsp;value;<br />
&nbsp;&nbsp;&nbsp;&nbsp;this.offset&nbsp;=&nbsp;offset;<br />
&nbsp;&nbsp;&nbsp;&nbsp;this.count&nbsp;=&nbsp;count;<br />
&nbsp;&nbsp;&nbsp;&nbsp;}</p>
<p>好吧,真相是jdk6 substring方法的实现采用的是原value保留,只是改变偏移量和count;一切都已经明朗了,集合中存储数据一直都的是全局变量的大小,所以当创建对象很多的情况下,一直累积,因为一直有引用,所以gc不掉 最终导致OOM了</p>
<p>第一种解决方案:修改getString方法实现,将截取后的值采用new出来的对象进行存储</p>
<p>String&nbsp;getString()&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;new&nbsp;String(this.strs.substring(0,&nbsp;2));</p>
<p>}</p>
<p>第二种解决方案:jdk切到jdk1.7.0_79</p>
<p>为什么切到1.7之后就可以了呢？因为jdk底层substring方法实现改了,我们还是继续看jdk7的substring方法实现</p>
<p>public&nbsp;String&nbsp;substring(int&nbsp;beginIndex,&nbsp;int&nbsp;endIndex)&nbsp;{</p>
<p>if&nbsp;(beginIndex&nbsp;&lt;&nbsp;0)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(beginIndex);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(endIndex&nbsp;&gt;&nbsp;value.length)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(endIndex);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int&nbsp;subLen&nbsp;=&nbsp;endIndex&nbsp;-&nbsp;beginIndex;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(subLen&nbsp;&lt;&nbsp;0)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(subLen);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;((beginIndex&nbsp;==&nbsp;0)&nbsp;&amp;&amp;&nbsp;(endIndex&nbsp;==&nbsp;value.length))&nbsp;?&nbsp;this<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;new&nbsp;String(value,&nbsp;beginIndex,&nbsp;subLen);<br />
&nbsp;&nbsp;&nbsp;&nbsp;}</p>
<p>public&nbsp;String(char&nbsp;value[],&nbsp;int&nbsp;offset,&nbsp;int&nbsp;count)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(offset&nbsp;&lt;&nbsp;0)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(offset);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(count&nbsp;&lt;&nbsp;0)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(count);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;Note:&nbsp;offset&nbsp;or&nbsp;count&nbsp;might&nbsp;be&nbsp;near&nbsp;-1&gt;&gt;&gt;1.<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(offset&nbsp;&gt;&nbsp;value.length&nbsp;-&nbsp;count)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;StringIndexOutOfBoundsException(offset&nbsp;+&nbsp;count);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;this.value&nbsp;=&nbsp;Arrays.copyOfRange(value,&nbsp;offset,&nbsp;offset+count);<br />
&nbsp;&nbsp;&nbsp;&nbsp;}</p>
<p>好吧！还真改了,采用Arrays.copyOfRange了</p>
<p>public&nbsp;static&nbsp;char[]&nbsp;copyOfRange(char[]&nbsp;original,&nbsp;int&nbsp;from,&nbsp;int&nbsp;to)&nbsp;{<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int&nbsp;newLength&nbsp;=&nbsp;to&nbsp;-&nbsp;from;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(newLength&nbsp;&lt;&nbsp;0)<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;throw&nbsp;new&nbsp;IllegalArgumentException(from&nbsp;+&nbsp;"&nbsp;&gt;&nbsp;"&nbsp;+&nbsp;to);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;char[]&nbsp;copy&nbsp;=&nbsp;new&nbsp;char[newLength];<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.arraycopy(original,&nbsp;from,&nbsp;copy,&nbsp;0,<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Math.min(original.length&nbsp;-&nbsp;from,&nbsp;newLength));<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;copy;</p>
<p>}</p>
<p>最终是采用的System.arraycopy意思是将截取后的字符串复制一份出来</p>
<p>这样就解决了jdk6内存溢出的问题了</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-04 05:41:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>jdk6 substring 内存泄露问题解析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ObPWP0.html" rel="bookmark">Java String&period;substring内存泄露？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				String可以说是最常用的Java类型之一了,但是最近听说JDK6里面String.substring存在内存泄露的bug,伙惊呆!一起来看看到底是啥情况吧. 这个是可以导致Exception in thread &quot;main&quot; java.lang.OutOfMemoryError: Java heap space 的代码: public class TestGC {     private String largeString = new String(new byte[100000			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4peZNPM.html" rel="bookmark">JAVA内存泄露原因解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 引言 Java的一个重要优点就是通过垃圾收集器GC (Garbage Collection)自动管理内存的回收,程序员不需要通过调用函数来释放内存.因此,很多程序员认为Java 不存在内存泄漏问题,或者认为即使有内存泄漏也不是程序的责任,而是GC 或JVM的问题.其实,这种想法是不正确的,因为Java 也存在内存泄漏,但它的表现与C++不同.如果正在开发的Java 代码要全天24 小时在服务器上运行,则内存漏洞在此处的影响就比在配置实用程序中的影响要大得多,即使最小的漏洞也会导致JVM耗尽全			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0R8WwP4.html" rel="bookmark">Java 内存泄漏--全解析和处理办法  &lbrack; 转载 &rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java内存泄露——全解析和处理办法 [转载] @author 小筐子 @address http://www.jianshu.com/p/bf159a9c391a 本文章会一步一步的探讨内存泄露的问题.博主第一次书写长篇技术贴,如有错误或不周到的地方请多指教. JAVA是垃圾回收语言的一种,开发者无需特意管理内存分配.但是JAVA中还是存在着许多内存泄露的可能性,如果不好好处理内存泄露,会导致APP内存单元无法释放被浪费掉,最终导致内存全部占据堆栈(heap)挤爆进而程序崩溃. 内存泄露 说到			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzXaY83.html" rel="bookmark">Java中的substring真的会引起内存泄露么</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Java中开发,String是我们开发程序可以说必须要使用的类型,String有一个substring方法用来截取字符串,我们想必也常常使用.但是你知道么,关于Java 6中的substring是否会引起内存泄露,在国外的论坛和社区有着一些讨论,以至于Java官方已经将其标记成bug,并且为此Java 7 还重新进行了实现.读到这里可能你的问题就来了,substring怎么会引起内存泄露呢?那么我们就带着问题,走进小黑屋,看看substring有没有内存泄露,又是怎么导致所谓的内存泄露. 基本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MymmyAM.html" rel="bookmark">&lbrack; Javascript &rsqb; 内存泄露以及循环引用解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内存泄露 在javascript中,我们非常少去关注内存的管理. 我们创建变量,使用变量,浏览器关注这些底层的细节都显得非常正常. 可是当应用程序变得越来越复杂而且ajax化之后,或者用户在一个页面停留过久,我们可能须要去注意一些问题.如一个浏览器花费了1G以上的内存,而且在不断的添加. 这些问题经常都是由于内存泄露引起. Javascript 内存泄露 这个javascript内存管理的核心概念就是具不具有可达性的概念. 1 一个明显的对象集合将会被觉得是可达的:这些对象是被知道的像roots			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWwGrbM.html" rel="bookmark">java 内存泄露</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要 说起Java的内存泄露,其实定义不是那么明确.首先,如果JVM没有bug,那么理论上是不会出现“无法回收的堆空间”,也就是说C/C++中的那种内 存泄露在Java中不存在的.其次,如果由于Java程序一直持有某个对象的引用,但是从程序逻辑上看,这个对象再也不会被用到了,那么我们可以认为这个 对象被泄露了.如果这样的对象数量很多,那么很明显,大量的内存空间就被泄露(“浪费”更准确一些)了. 目录[-] 分析内存泄露的一般步骤 dump heap analyze heap 原因解释 解决方案			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP1nka0.html" rel="bookmark">String&period;split引发的&OpenCurlyDoubleQuote;内存泄露&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一直赞叹Sun对待技术的严谨和优雅(bless Sun).Sun JDK中Java库的源代码,连注释都清清楚楚.规规范范,javadoc注解的使用也一丝不苟,读起来很熟舒服.因此,在日常工作和学习中,经常读读 Java库的源代码,不亦乐乎?如果遇到诡异问题,源代码的帮助就更大了. 闲话少说,回归正题.这几天,一直在为Java的“内存泄露”问题纠结.Java应用程序占用的内存在不断的.有规律的上涨,最终超过了监控阈值. 福尔摩斯不得不出手了! 说起Java的内存泄露,其实定义不是那么明确.首先,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38ZNwAM.html" rel="bookmark">Layer的内存泄露问题分析报告</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[问题描述] home应用在运行monkey测试6个小时候,Native Heap增长到200MB,怀疑内存泄露. 我们可以动过dumpsys查看Native Heap的大小: $adb shell dumpsys meminfo com.miui.home Applications Memory Usage (kB): Uptime: 12929068 Realtime: 12929060 ** MEMINFO in pid 1393 [com.miui.home] ** Pss Privat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dxXqr0.html" rel="bookmark">充满BUG的世界观&mdash;&mdash;再遇Java内存泄露</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				发现内存泄露除了仔细看代码的确没有太好的方法.首先看gc log, 确定是内存泄露,而不是内存不够.内存泄露的特点就是以每次Full GC后使用的最低内存为起点,拟合一条线.如果这条线是随时间递增的一条曲线,那么很大程度上代表着内存泄露. 然后使用 jmap -histo [pid] 来查看你的所有对象所占内存的比例.你可能很不幸的发现[B 这个byte数组对象占用了绝大多数.这的确没有更好的方法了.只能一点点的看代码.检查一下有没有写成循环的地方.检查一下有没有申请的内存没有释放.检查一下全局			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g417Gq0.html" rel="bookmark" class="title">linux &sol;proc&sol;sys&sol;vm&sol;中各个文件含义</a>
					<div>
						1)      /proc/sys/vm/block_dump该文件表示是否打开Block Debug模式,用于记录所有的读写及Dirty Block写回动作. 缺省设置:0,禁用Block Debu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MVlEk3.html" rel="bookmark" class="title">POJ 1228 Grandpa&amp;&num;39&semi;s Estate &lbrack;稳定凸包&rsqb;</a>
					<div>
						Grandpa's Estate Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 13112   Accepted: 3697 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/AMDWGY4.html" rel="bookmark" class="title">微信支付v3发布到iis时的证书问题</a>
					<div>
						找了问题半天,调试没有问题,但是放到网站上就报错.最后解决方法. 一开始报“出现了内部错误” 解决方法是 方法一 var cer = new X509Certificate(certpath, pas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4APRnd3.html" rel="bookmark" class="title">Android开发中常用工具</a>
					<div>
						1. Android虚拟设备和SDK管理器:用于创建和管理AVD以及下载SDK包.2. Android模拟器:Android虚拟机的实现,目的是使开发的应用在开发计算机上的AVD内运行.3. Andr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYzlQ0.html" rel="bookmark" class="title">java-GUI图形用户界面</a>
					<div>
						图形用户界面GUI(Graphical User Interface),指的是在一个程序中用户可以看到的和与之交互的部分. JavaAPI中提供两套组件用于支持编写用户界面AWT  and  Swin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8OEq3.html" rel="bookmark" class="title">poj3050</a>
					<div>
						Hopscotch Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%lld &amp; %llu Submit Stat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mom6NP3.html" rel="bookmark" class="title">关于源码泄露的应急响应</a>
					<div>
						近来,国内互联网公司安全事件频发,有公司内部源码被发现托管在github上,从而引发安全隐患. 作为一家具备危机公关的公司,面对这样的事件,应该有自己的一套详尽的流程: 如:1.第一时间通知公司危机公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6bQpWM.html" rel="bookmark" class="title">维护的JSP站点数据丢失</a>
					<div>
						两个月前换了份工作,然后接手了三台server.上面乱七八糟的网站和应用大把. 当中有维护一个瀚石苑:http://www.hanshiyuan.com/.三天两头的丢失数据. 都不知道怎么找回,好在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5jwj0.html" rel="bookmark" class="title">Linux下make与makefile</a>
					<div>
						make 用来解析 makefile 文件 make 的选项: -d 显示调试信息 -f 文件 默认是从 makefile 或 Makefile 中读取依赖信息,用该选项可更改文件 -h 显示所有 m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWgm83.html" rel="bookmark" class="title">黑马程序员&mdash;&mdash;java基础&mdash;&mdash;反射</a>
					<div>
						﻿﻿ 黑马程序员--java基础--反射 ------Java培训.Android培训.iOS培训..Net培训.期待与您交流! ------- 反射 其实就是动态加载一个指定的类,并获取该类中的所有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QwE5e0.html" rel="bookmark" class="title">15分钟学会git基本的操作命令</a>
					<div>
						http://hao.jobbole.com/try-git/ 假如你现在新创建了一个项目,想把它提交到github上面? 假设你创建好了一个项目,并切换到项目的根目录下面: $ git status ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRez54.html" rel="bookmark" class="title">卡塔兰数（Catalan）</a>
					<div>
						卡塔兰数(Catalan) 原理: 令h(0)=1,h(1)=1. 卡塔兰数满足递推式:h(n)=h(0)*h(n-1)+h(1)*h(n-2) + ... + h(n-1)h(0)(n&gt;=2) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAeAQ3.html" rel="bookmark" class="title">Android开发60条技术经验总结</a>
					<div>
						Android开发60条技术经验总结,以下是全文: 1. 全部Activity可继承自BaseActivity,便于统一风格与处理公共事件,构建对话框统一构建器的建立,万一需要整体变动,一处修改到处有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/351plX3.html" rel="bookmark" class="title">JavaScript：闭包</a>
					<div>
						一.充电 1.一切(引用类型)都是对象,对象是属性的集合. 2.函数是一种对象,但是函数却不像数组一样--你可以说数组是对象的一种,因为数组就像是对象的一个子集一样.但是函数与对象之间,却不仅仅是一种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QooeN0.html" rel="bookmark" class="title">JS控制CSS3，添加浏览器兼容前缀</a>
					<div>
						不同浏览器对于有些css3属性名字定义的时候,会带上特有的前缀,所以在css编写的时候,经常会一个属性写多个不同的前缀进行兼容.比如: div { transform: rotate(30deg);  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JjZaQ4.html" rel="bookmark" class="title">javase基础学完可以做什么，javase实现局域网聊天室</a>
					<div>
						包含内容:基础语法,面向对象,多线程,IO流,GUI编程,网络编程(udp) 实现功能:局域网群聊,局域网群发文件(还不太完善,只能传输小体积的文本文件) 由于本人也是刚开始学java,而且掌握的不太 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4N1dEZ3.html" rel="bookmark" class="title">VSFTP服务理论</a>
					<div>
						应用层:ftp: 内核级网络文件系统:nfs POSIX API 跨平台的网络文件系统:cifs (samba) 网络存储: NAS:Network Attached Stoage,文件系统级接口:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lDLEX0.html" rel="bookmark" class="title">数据结构--ArrayList的Java实现</a>
					<div>
						上代码: package com.itany.MyArrayList; import java.util.Iterator; public class MyArrayList&lt;T&gt; imp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qgj6w0.html" rel="bookmark" class="title">JDK安装与环境变量配置&lpar;Win7&rpar;</a>
					<div>
						1.下载JDK(Java SE Development Kit) 地址:http://www.oracle.com/technetwork/java/javase/downloads/jdk8-dow ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVWvkk0.html" rel="bookmark" class="title">hdu1328卿学姐与诡异村庄</a>
					<div>
						地址:http://acm.uestc.edu.cn/#/problem/show/1328 题目: 卿学姐与诡异村庄 Time Limit: 4500/1500MS (Java/Others)    ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
